#include <sys/types.h>
#include <sys/socket.h>
#include <sys/wait.h>
#include <sys/stat.h>
#include <netinet/in.h>
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>

#include "proto.h"

#define MYPORT 5002
#define saram 10

main(int argc, char *argv[])
{
	FILE *fp;
		
	char data[1024];
	int sf,nf,sin_size;
	int ret,nr;
	int option;
	float cou=0;
	
	struct sockaddr_in my_addr;
	struct sockaddr_in to_addr;
	if((sf=socket(AF_INET, SOCK_STREAM, 0))==-1) {
		perror("socket");
		exit(1);
	}
	
	struct header header_t;
	struct stat sta;
	
	stat(argv[1],&sta);
	
	printf("\n ũ: %d\n",sizeof(header_t));
	strcpy(header_t.f_name,argv[2]);
	header_t.f_size=sta.st_size;
	my_addr.sin_family=AF_INET;
	my_addr.sin_port=htons(MYPORT);
	my_addr.sin_addr.s_addr=inet_addr(argv[1]);
	bzero(&(my_addr.sin_zero),8);
	setsockopt(sf,SOL_SOCKET,SO_REUSEADDR,&option,sizeof(option));

	if(bind(sf,(struct sockaddr *)&my_addr,sizeof(struct sockaddr))==-1) {
		perror("bind");
		exit(1);
	}
	
	if(listen(sf,saram)==-1) {
		perror("listen");
		exit(1);
	}
	while(1) {
		fp=fopen(argv[2],"rb");
		sin_size=sizeof(struct sockaddr_in);
		if((nf=accept(sf,(struct sockaddr *)&to_addr,&sin_size))==-1) {
				perror("accept");
				continue;
		}
		
		printf("server: got connection from %s\n",
				inet_ntoa(to_addr.sin_addr));
		
		if (!fork()) {
			/*if (send(nf,"ȳ?\n",10,0)==-1)
				perror("send");
			*/
			printf(" : %s\n",header_t.f_name);
			printf(" ũ  : %d\n",header_t.f_size);
			send(nf,&header_t,sizeof(header_t),0);
			while (1){
				nr=fread(data,1,1024,fp);
				ret=send(nf,data,nr,0);
				
				cou+=ret;
				printf(" %.1f KB",cou/1024);
				printf("\r");
				
				if(feof(fp)) break;
			}
			
			fclose(fp);
			close(nf);
			exit(0);
		}
		close(nf);
		while (waitpid(-1,NULL,WNOHANG) > 0);
	
	}
}

	
	
	

